#ifndef UDP_CLIENT_SERVICE_H
#define UDP_CLIENT_SERVICE_H

//client services header file

#include <SDL_net.h>
#include <cstring>
#include <stdio.h>
#include <stdlib.h>
#include <iostream>


#define IP 0
#define PORT 1
#define MSG 2

const int MAX_PACKETS = 3;

class UDP_Client_Service
{
  public:
    UDP_Client_Service(std::string, std::string, std::string, std::string); //recieves IP & port # to connect to
    ~UDP_Client_Service(void);          //frees any allocated memory and shuts things down.

    void send_msg(std::string);              //sends a message to the server

    void show_dest_info(void) const;    //displays packet destination information.
    
  private:
    void send_logon(void);        //sends local IP address and listening port to server so it can reply
                                  //used at end of initialization.

    void resolve_server_address(void);  //used during initialization to init variables.
    
    UDPsocket sd_send;           //socket descriptor for sending 

    UDPpacket **p_send;          //packet to be sent (login, messages, etc)

    IPaddress server_address;    //IP address of the server
    
    std::string server_ip;
    std::string server_port;
    std::string local_ip;
    std::string local_port;
  

    
};

#endif
