/*

  Code is getting a bit jumbly. Need to update the client software so I can send a vector of
  packets at once. I want the client to send "command msg" "ip address" and "open port" to the
  server software so it knows how to respond correctly. I'm too tired to do it now so I'll just
  do it tomorrow morning probably.
  
  Func prototypes needed:
  ------------------------
    UDPpacket** SDLNet_AllocPacketV(int howmany, int size);                     - allocate it
    void SDLNet_FreePacketV(UDPpacket **packetV);                               - free it
    int SDLNet_UDP_SendV(UDPsocket sock, UDPpacket **packets, int npackets);    - send it
    int SDLNet_UDP_RecvV(UDPsocket sock, UDPpacket **packets);                  - recieve it
    
    
  Also need to put incoming packets into a stack buffer so that they won't be lost when another
  packet comes in. 
  
    ->"reply()" needs to be written to check to see if there's items on the bottom of the buffer (send them in order)
      and if isEmpty() == false read oldest packet info and reply to it. Keep doing this until the
      buffer is empty.
      
    ->New packets that come in get throw to the top, not handled right away.
*/




// UDP_Server_Service class implementation file


#include "UDP_Server_Service.h"
#include <cstdlib>


UDP_Server_Service::UDP_Server_Service(std::string ip_to_set, std::string port_to_set)
{

  local_ip = ip_to_set;
  local_port = port_to_set;

  if (local_port != "0")
    std::cout << "Accepting connections on port: " << local_port << std::endl;
  
  else
  {
    local_port = 4555;
    printf("\nNo port given...\nDefaulting to port 4555...\n");
  }
  
  printf("Initializing SDL_net (recieve)...");  
  if (SDLNet_Init() < 0)    //init sdl_net
  {
    fprintf(stderr, "FAILED!\nSDLNet_Init: %s\n", SDLNet_GetError());
    exit(1);
  }
  printf("Success!\n");
  
  // open socket on port given
  
  std::cout << "Opening port %d for incoming connections..." << local_port;
  if (!(sd_recieve = SDLNet_UDP_Open(static_cast<Uint16>(atoi(local_port.c_str())))))
  {
    fprintf(stderr, "FAILED!\nSDLNet_UDP_Open(port): %s\n", SDLNet_GetError());
    exit(1);
  }
  printf("Success!\n");

  
  //init destination address
  resolve_server_address();
  
  
  // allocate space for the inbound packet
  printf("Allocating memory for recieving packets...");
  if (!(p_recieve = SDLNet_AllocPacketV(3, 512)))
  {
    fprintf(stderr, "FAILED!\nSDLNet_AllocPacket(512): %s\n", SDLNet_GetError());
    exit(1);
  }
  printf("Success!\n\n");
}

UDP_Server_Service::~UDP_Server_Service()
{
    //close sockets.
    SDLNet_UDP_Close(sd_recieve);
    printf("Shutting down sending client...\n");
    printf("Done!\nShutting down recieving client...\n");
    printf("Freeing allocated memory for inbound packets...");        
    SDLNet_FreePacketV(p_recieve);
    printf("Done!\nExiting SDLNet and terminating server...");
    SDLNet_Quit();
    printf("Done!\n");
    
}

  
int UDP_Server_Service::recieve_data(void) 
{
 // bool inner_wait = true;
  Uint16 numRecv;
  Uint32 data_recieved[3];
  std::string data_view[3];

  std::string internal_msg;

  numRecv = SDLNet_UDP_RecvV(sd_recieve, p_recieve);

  if (numRecv > 0)
  {
    std::cout << "# Packets recieved: " << numRecv << std::endl;
    std::cout << "Converting data to readable information...\n";
    
    data_recieved[IP] = SDLNet_Read32(p_recieve[IP]->data);
    data_view[IP] = data_recieved[IP];
    
    std::cout << "Viewing packet info..\n";
    std::cout << "Packet vector incoming!\n";
	//04-04-18 - Fixing so message is displayed again.
	/*
    std::cout << "\t  IP: " << data_recieved[IP] << std:: endl; //SDLNet_Read32(p_recieve[IP]->data) << std::endl;
    std::cout << "\tPORT: " << SDLNet_Read16(p_recieve[PORT]->data) << std::endl;
	std::cout << "\t MSG: " << SDLNet_Read16(p_recieve[MSG]->data) << std::endl;
	*/
    std::cout << "\t  IP: " << p_recieve[IP]->data << std::endl; 
    std::cout << "\tPORT: " << p_recieve[PORT]->data << std::endl;
	std::cout << "\t MSG: " << p_recieve[MSG]->data << std::endl;	

	/*
    //if they sent the quit command    
    if (!strcmp(SDLNet_Read32(p_recieve[MSG]->data), "quit"))
    {
      system("clear");
      printf("\nServer recieved \"quit\" signal from client!\n");
      return 0;
    }
	*/
	//04-04-18: Fixing this as well...
    if (!strcmp((char*)p_recieve[MSG]->data, "quit"))
    {
      printf("\nServer recieved \"quit\" signal from client!\n");
      return 0;
    }

  }
  
 
  
  return 1;
}

void UDP_Server_Service::resolve_server_address(void)
{
  
  printf("Resolving destination address...");
  if (SDLNet_ResolveHost(&destadd, NULL, static_cast<Uint16>(atoi(local_port.c_str()))))
  {
    fprintf(stderr, "FAILED!\nSDLNet_ResolveHost(%s %s): %s\n", local_ip.c_str(), local_port.c_str(), SDLNet_GetError());
    exit(1);
  }
  printf("Success!\n");
}

