#ifndef UDP_SERVER_SERVICE_H
#define UDP_SERVER_SERVICE_H

// server object header file

#include <SDL_net.h>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <iostream>

#define IP 0
#define PORT 1
#define MSG 2



class UDP_Server_Service
{
  public:
    UDP_Server_Service(std::string, std::string);  //recieves local IP & port number to open (recieve info)
    ~UDP_Server_Service();  
    int recieve_data(void) ;             //scan for packets sent to server
    
  private:
    void resolve_server_address(void);  //used during initialization to init variables.
    
    UDPsocket sd_recieve;        //socket descriptor for recieving 
    UDPpacket **p_recieve;        //packet data pointer to recieved info (server recieve from clients)
    IPaddress destadd;           //destinations ip address
    
    std::string local_ip;       //destination IP used for redirecting packet traffic
    std::string local_port;       //same as above but with the destination port.        

    
};
  
#endif
